/***********************************************************************
 * Virus Game Fix
 *	
 *	  Application which will launch and adjust Virus Game time.
 *
 *     Virus is a 1997 Game and it runs too fast on modern computers. This
 *     application allows you to adjust the speed of the game.
 *
 *
 * Toby Opferman Copyright (c) 2014
 *
 ***********************************************************************/
  
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <psapi.h>
#include <Shlwapi.h>
#include "virus.h"

typedef struct _GAME_FIX_CTX
{
	HANDLE hProcess;
	HANDLE hThread;
	unsigned char *pRemoteProcessMemory;
	unsigned char *pStartOfVirusExe;
	ULONG Milliseconds;
	ULONG CpuMhz;
	BOOL bBusyLoop;
	
} GAME_FIX_CTX, *PGAME_FIX_CTX;


#define GAME_PATCH_OFFSET			 0x1e264
#define GAME_RENDER_FUNCTION_OFFSET	 0x5b491
#define GAME_THIS_POINTER_OFFSET	 0xeae48
#define DEFAULT_TIMER				 15

/*
 * The code to be patched:
 *
 * 0041e25e 8b0d48ae4e00	mov		ecx,dword ptr [image00400000+0xeae48 (004eae48)]
 * image00400000+0x1e264:
 * 0041e264 e828d20300		call	image00400000+0x5b491 (0045b491)
 * 
 */

/*
 * Internal Prototypes
 */
BOOL VirusGameFix_LaunchGame(PGAME_FIX_CTX pGameFixCtx);
void VirusGameFix_ResumeGame(PGAME_FIX_CTX pGameFixCtx);
void VirusGameFix_TerminateGame(PGAME_FIX_CTX pGameFixCtx);
BOOL VirusGameFix_InitMemory(PGAME_FIX_CTX pGameFixCtx);
BOOL VirusGameFix_PatchGame(PGAME_FIX_CTX pGameFixCtx);
BOOL VirusGameFix_PatchGame_PatchRenderFunction(PGAME_FIX_CTX pGameFixCtx);
BOOL VirusGameFix_PatchGame_CreateTimingFunction(PGAME_FIX_CTX pGameFixCtx);
BOOL WINAPI VirusGameFix_ConfigDialog(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);

 /***********************************************************************
  * main
  *
  *	   Entry Point
  *
  * Parameters
  *		Standard console Entry Point Parameters
  * 
  * Return Value
  *		Result of the program
  *
  ***********************************************************************/
 int __cdecl main(UINT argc, char **argv)
 {
	 GAME_FIX_CTX GameFixCtx = {0};
	 BOOL bArgsInit;
	 
	 if(argc == 4 || argc == 1)
	 {
	     bArgsInit = FALSE;
		 
		if(argc == 4)
        {		
			GameFixCtx.Milliseconds = (ULONG)atoi(argv[1]);
			
			if(GameFixCtx.Milliseconds == 0)
			{
			   GameFixCtx.Milliseconds = DEFAULT_TIMER;
			}
			
			GameFixCtx.CpuMhz = (ULONG)atoi(argv[2]);
			
			if(GameFixCtx.CpuMhz == 0)
			{
			   GameFixCtx.CpuMhz = 3000;
			}	

			GameFixCtx.bBusyLoop = (BOOL)atoi(argv[3]);
			
			bArgsInit = TRUE;
		}
		else
		{
           bArgsInit = DialogBoxParam(NULL, MAKEINTRESOURCE(IDD_CONFIG_DLG), HWND_DESKTOP, VirusGameFix_ConfigDialog, (LPARAM)&GameFixCtx);
		}
		 
		 if(bArgsInit)
		 {
			 if(VirusGameFix_LaunchGame(&GameFixCtx))
			 {
				
				if(VirusGameFix_InitMemory(&GameFixCtx))
				{
					if(VirusGameFix_PatchGame(&GameFixCtx))
					{
					   VirusGameFix_ResumeGame(&GameFixCtx);
					}
					else
					{
					   printf("patching game failed\n");
					   VirusGameFix_TerminateGame(&GameFixCtx);
					}
				}
				else
				{
					printf("Initialization of memory failed\n");
					VirusGameFix_TerminateGame(&GameFixCtx);
				}
			 }
			 else
			 {
				 printf("Failed to launch game.	 Make sure this executable is in the same folder as the game.\n");
			 }	 
	    }
	 }
	 else
	 {
		printf("virusgamefix [Milliseconds] [MHZ] [Busy Loop]\n");
		printf("			  Milliseconds = Delay time in milliseconds.\n");
		printf("			  MHZ = MHZ of your processor (i.e. 1GHZ = 1000MHZ).\n");
		printf("			  Busy Loop = 0 is no busy loop; any other number is busy loop\n");	 
		printf("			  Busy loop may help to prevent game from updating character movements\n");	 
		printf("			  and camera too fast but also may cause ghosting.\n\n");	 
		printf("			  Specify 0 parameters to get the config dialog\n");	 
		
	 }
		 
	 return 0;
 }

 
  /***********************************************************************
  * VirusGameFix_LaunchGame
  *
  *	   
  *
  * Parameters
  *		
  * 
  * Return Value
  *		Handle to the process
  *
  ***********************************************************************/
BOOL VirusGameFix_LaunchGame(PGAME_FIX_CTX pGameFixCtx)
{
	STARTUPINFO StartupInfo = {0};
	PROCESS_INFORMATION ProcessInfo;
	BOOL bProcessStarted;
	
	StartupInfo.cb = sizeof(StartupInfo);
		
	bProcessStarted = CreateProcess("virus.exe", NULL, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS | CREATE_SUSPENDED, NULL, NULL, &StartupInfo, &ProcessInfo);
	
	if(bProcessStarted)
	{
		pGameFixCtx->hProcess = ProcessInfo.hProcess;
		pGameFixCtx->hThread  = ProcessInfo.hThread;
		
		/*
		 * Need to have the process run in order to get the modules loaded.
		 */
		ResumeThread(pGameFixCtx->hThread);
		Sleep(1000);
		SuspendThread(pGameFixCtx->hThread);
	}
	
	return bProcessStarted;
}


  /***********************************************************************
  * VirusGameFix_ResumeGame
  *
  *	   
  *
  * Parameters
  *		
  * 
  * Return Value
  *		
  *
  ***********************************************************************/
void VirusGameFix_ResumeGame(PGAME_FIX_CTX pGameFixCtx)
{
	ResumeThread(pGameFixCtx->hThread);
	CloseHandle(pGameFixCtx->hProcess);
	CloseHandle(pGameFixCtx->hThread);
}


  /***********************************************************************
  * VirusGameFix_PatchGame
  *
  *	   
  *
  * Parameters
  *		
  * 
  * Return Value
  *	   
  *
  ***********************************************************************/
BOOL VirusGameFix_InitMemory(PGAME_FIX_CTX pGameFixCtx)
{
   BOOL bInitializedMemory = FALSE;
   MODULEINFO ModuleInfo;
   HMODULE hModules[1024];
   ULONG SizeOfData;
   ULONG Index;
   char szModName[256];
   
   pGameFixCtx->pRemoteProcessMemory = VirtualAllocEx(pGameFixCtx->hProcess, NULL, 0x1000, MEM_COMMIT | MEM_RESERVE, PAGE_EXECUTE_READWRITE);
   
   if(pGameFixCtx->pRemoteProcessMemory)
   {
	   if(EnumProcessModules(pGameFixCtx->hProcess, hModules, sizeof(hModules), &SizeOfData))
	   {
		   for(Index = 0; Index < (SizeOfData / sizeof(HMODULE)) && bInitializedMemory == FALSE; Index++)
		   {
				if(GetModuleFileNameEx( pGameFixCtx->hProcess, hModules[Index], szModName, sizeof(szModName)))
				{
					 printf("%s (0x%08X)\n", szModName, hModules[Index]);
					 
					 if(StrStrI(szModName, "virus.exe"))
					 {
						 pGameFixCtx->pStartOfVirusExe = (unsigned char *)hModules[Index];
						 bInitializedMemory = TRUE;
					 }
				}
		   }
		}
		else
		{
			printf("Failed to retrieve process image address 0x%0x\n", GetLastError());
		}		
   }  
   else
   {
	   printf("Cannot allocate memory in remote process 0x%0x\n", GetLastError());
   }
   
   return bInitializedMemory;
}


  /***********************************************************************
  * VirusGameFix_TerminateGame
  *
  *	   
  *
  * Parameters
  *		
  * 
  * Return Value
  *	   
  *
  ***********************************************************************/
void VirusGameFix_TerminateGame(PGAME_FIX_CTX pGameFixCtx)
{
	TerminateProcess(pGameFixCtx->hProcess, 0);
	CloseHandle(pGameFixCtx->hProcess);
	CloseHandle(pGameFixCtx->hThread);
}



 /***********************************************************************
  * VirusGameFix_PatchGame
  *
  *	   
  *
  * Parameters
  *		
  * 
  * Return Value
  *	   
  *
  ***********************************************************************/
BOOL VirusGameFix_PatchGame_PatchRenderFunction(PGAME_FIX_CTX pGameFixCtx)
{
   unsigned char szPatchFunctionBuffer[20];
   unsigned char szVerifyBytes[5] = {0xe8, 0x28, 0xd2, 0x03, 0x00};
   BOOL bFunctionPatched = FALSE;
   BOOL bBytesVerified;
   ULONG BytesOut;
   ULONG Index;
   ULONG RelativeAddress;
   
   if(ReadProcessMemory(pGameFixCtx->hProcess, pGameFixCtx->pStartOfVirusExe + GAME_PATCH_OFFSET, szPatchFunctionBuffer, sizeof(szPatchFunctionBuffer), &BytesOut))
   {
	   bBytesVerified = TRUE;
	   
	   for(Index = 0; Index < 5 && bBytesVerified; Index++)
	   {	 
		   if(szVerifyBytes[Index] != szPatchFunctionBuffer[Index])	 
		   {
			   printf("Failed to verify function patching bytes\n");
			   bBytesVerified = FALSE;			   
		   }
	   }
	   
	   if(bBytesVerified)
	   {
		  RelativeAddress = (ULONG)(pGameFixCtx->pRemoteProcessMemory - (pGameFixCtx->pStartOfVirusExe + GAME_PATCH_OFFSET + 5));
		  
		  for(Index = 0; Index < 4 && bBytesVerified; Index++)
		  {	 
			  szPatchFunctionBuffer[Index+1] = (unsigned char)RelativeAddress;
			  RelativeAddress >>=8;
		  }
		  
		  if(WriteProcessMemory(pGameFixCtx->hProcess, pGameFixCtx->pStartOfVirusExe + GAME_PATCH_OFFSET + 1, &szPatchFunctionBuffer[1], 4, &BytesOut))
		  {
			 bFunctionPatched = TRUE;
		  }
		  else
		  {
			 printf("Could not write process memory 0x%0x\n", GetLastError());
		  }
	   }
   }
   else
   {
	   printf("Could not read process memory 0x%0x\n", GetLastError());
   }

	return bFunctionPatched;
}



/***********************************************************************
  * VirusGameFix_PatchGame
  *
  *	   
  *
  * Parameters
  *		
  * 
  * Return Value
  *	   
  *
  ***********************************************************************/
BOOL VirusGameFix_PatchGame(PGAME_FIX_CTX pGameFixCtx)
{
	BOOL bPatchComplete = FALSE;
	
	if(VirusGameFix_PatchGame_PatchRenderFunction(pGameFixCtx))
	{
		bPatchComplete =  VirusGameFix_PatchGame_CreateTimingFunction(pGameFixCtx);
	}
		
	return bPatchComplete;
}



/***********************************************************************
  * VirusGameFix_ConfigDialog
  *
  *	   
  *
  * Parameters
  *		
  * 
  * Return Value
  *	   
  *
  ***********************************************************************/
BOOL WINAPI VirusGameFix_ConfigDialog(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
    BOOL bHandled = FALSE;
	PGAME_FIX_CTX pGameFixCtx;
	
	switch(Msg)
	{
	    case WM_INITDIALOG:
		     SetWindowLong(hDlg, GWL_USERDATA, (ULONG)lParam);
		     SetDlgItemInt(hDlg, ID_MHZ, 3000, FALSE);
  		     SetDlgItemInt(hDlg, ID_MS, 15, FALSE);
			 SetDlgItemInt(hDlg, ID_BUSY, 1, FALSE);			 
			 bHandled = TRUE;
			 break;
			 
	    case WM_COMMAND:
		     switch(LOWORD(wParam))
			 {
			      case IDOK:
				       pGameFixCtx = (PGAME_FIX_CTX)GetWindowLong(hDlg, GWL_USERDATA);
				       pGameFixCtx->CpuMhz = GetDlgItemInt(hDlg, ID_MHZ, NULL, FALSE);
					   pGameFixCtx->Milliseconds = GetDlgItemInt(hDlg, ID_MS, NULL, FALSE);
					   pGameFixCtx->bBusyLoop = GetDlgItemInt(hDlg, ID_BUSY, NULL, FALSE);
				       EndDialog(hDlg, TRUE);
					   bHandled = TRUE;
					   break;
					   
				  case IDCANCEL:
				       EndDialog(hDlg, FALSE);
					   bHandled = TRUE;
					   break;
			 }
			 break;
	}
 
    return bHandled;
}

/***********************************************************************
  * VirusGameFix_PatchGame_CreateTimingFunction
  *
  *	   
  *
  * Parameters
  *		
  * 
  * Return Value
  *	   
  *
  ***********************************************************************/
BOOL VirusGameFix_PatchGame_CreateTimingFunction(PGAME_FIX_CTX pGameFixCtx)
{
   unsigned char szAllocatedBuffer[0x1000];
   unsigned char szPatchingInstructions[] = 
{0x0f, 0x31, 0x2b, 0x05, 0x00, 0x05, 0x83, 0x00, 0x1b, 0x15, 0x04, 0x05, 0x83, 0x00, 0x3e, 0x3b,
0x15, 0x0c, 0x05, 0x83, 0x00, 0x77, 0x1b, 0x72, 0x2b, 0x3b, 0x05, 0x08, 0x05, 0x83, 0x00, 0x72,
0x23, 0xeb, 0x0f, 0x08, 0x05, 0x83, 0x00, 0x83, 0x99, 0xff, 0x9a, 0x88, 0xb8, 0x01, 0x00, 0x00,
0x00, 0xc3, 0x0f, 0x31, 0xa3, 0x00, 0x05, 0x83, 0x00, 0x89, 0x15, 0x04, 0x05, 0x83, 0x00, 0xe8,
0x4d, 0xb4, 0xc2, 0xff, 0xb8, 0x01, 0x00, 0x00, 0x00, 0xc3 };
   BOOL bFunctionPatched = FALSE;
   UINT Index;
   ULONG RemoteLowSaved;
   ULONG RemoteHighSaved;
   ULONG RemoteLowTarget;
   ULONG RemoteHighTarget;
   ULONG RelativeAddressOfRenderFunction;
   ULONG64 TargetTime;
   ULONG BytesOut;
   
   memcpy(szAllocatedBuffer, szPatchingInstructions, sizeof(szPatchingInstructions));

   RemoteLowSaved = ((ULONG)pGameFixCtx->pRemoteProcessMemory) + 0x500;
   RemoteHighSaved = ((ULONG)pGameFixCtx->pRemoteProcessMemory) + 0x504;
   RemoteLowTarget = ((ULONG)pGameFixCtx->pRemoteProcessMemory) + 0x508;
   RemoteHighTarget = ((ULONG)pGameFixCtx->pRemoteProcessMemory) + 0x50C;
   RelativeAddressOfRenderFunction = ((ULONG)pGameFixCtx->pStartOfVirusExe + GAME_RENDER_FUNCTION_OFFSET) - ((ULONG)pGameFixCtx->pRemoteProcessMemory + 0x44);
   
   /*
	* Address fix ups to access global variables that store the 
	* Address of the last time and the address of the expiration time.
	*/
   for(Index = 0; Index < 4; Index++)
   {
	  szAllocatedBuffer[4+Index] = (unsigned char)RemoteLowSaved;
	  szAllocatedBuffer[10+Index] = (unsigned char)RemoteHighSaved;
	  szAllocatedBuffer[17+Index] = (unsigned char)RemoteHighTarget;
	  szAllocatedBuffer[0x1B+Index] = (unsigned char)RemoteLowTarget;
	  szAllocatedBuffer[0x35+Index] = (unsigned char)RemoteLowSaved;
	  szAllocatedBuffer[0x3B+Index]	= (unsigned char)RemoteHighSaved;
	  szAllocatedBuffer[0x40+Index]	= (unsigned char)RelativeAddressOfRenderFunction;
	  
	  RemoteLowSaved >>= 8;
	  RemoteHighSaved >>= 8;
	  
	  RemoteLowTarget >>= 8;
	  RemoteHighTarget >>= 8;
	  
	  RelativeAddressOfRenderFunction >>=8;
   }
   
   if(pGameFixCtx->bBusyLoop)
   {
	   szAllocatedBuffer[0x18]	= 0xE7;
	   szAllocatedBuffer[0x20]	= 0xDF;
   }
   
   TargetTime = 1000 * pGameFixCtx->Milliseconds * pGameFixCtx->CpuMhz;
   
   *((ULONG *)&szAllocatedBuffer[0x508]) = (ULONG)TargetTime;
   *((ULONG *)&szAllocatedBuffer[0x50C]) = (ULONG)(TargetTime>>32);
 
   if(WriteProcessMemory(pGameFixCtx->hProcess, pGameFixCtx->pRemoteProcessMemory, szAllocatedBuffer, sizeof(szAllocatedBuffer), &BytesOut))
   {
	  bFunctionPatched = TRUE;
   }
   else
   {	
	  printf("Could not write process memory 0x%0x\n", GetLastError());
   }

   return bFunctionPatched;
}

/*
00830000 0f31			 rdtsc
00830002 2b0500058300	 sub	 eax,dword ptr ds:[830500h]
00830008 1b1504058300	 sbb	 edx,dword ptr ds:[830504h]
0083000e 3e3b150c058300	 cmp	 edx,dword ptr ds:[83050Ch]
00830015 771b			 ja		 00830032
00830017 722b			 jb		 00830044
00830019 3b0508058300	 cmp	 eax,dword ptr ds:[830508h]
0083001f 7223			 jb		 00830044
00830021 eb0f			 jmp	 00830032
00830023 080583008399	 or		 byte ptr ds:[99830083h],al
00830029 ff9a88b80100	 call	 fword ptr [edx+1B888h]
0083002f 0000			 add	 byte ptr [eax],al
00830031 c3				 ret
00830032 0f31			 rdtsc
00830034 a300058300		 mov	 dword ptr ds:[00830500h],eax
00830039 891504058300	 mov	 dword ptr ds:[830504h],edx
0083003f e84db4c2ff		 call	 virus+0x5b491 (0045b491)
00830044 b801000000		 mov	 eax,1
00830049 c3				 ret
*/





